uva 11584 Partitioning by Palindromes

2024-03-24 08:48

本文主要是介绍uva 11584 Partitioning by Palindromes,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

原题:
We say a sequence of characters is a palindrome if it is the same written forwards and backwards. For example, ‘racecar’ is a palindrome, but ‘fastcar’ is not.A partition of a sequence of characters is a list of one or more disjoint non-empty groups of consecutive characters whose concatenation yields the initial sequence. For example, (‘race’,‘car’) is a partition of ‘racecar’ into
two groups.Given a sequence of characters, we can always create a partition of these characters such that each group in the
partition is a palindrome! Given this observation it is natural to ask: what is the minimum number of groups needed for a given string such that every group is a palindrome?
For example:
• ‘racecar’ is already a palindrome, therefore it can be partitioned into one group.
• ‘fastcar’ does not contain any non-trivial palindromes, so it
must be partitioned as (‘f’, ‘a’,‘s’, ‘t’, ‘c’, ‘a’, ‘r’).
Can you read upside-down?
• ‘aaadbccb’ can be partitioned as (‘aaa’, ‘d’, ‘bccb’).
Input
Input begins with the number n of test cases. Each test case consists of a single line of between 1 and
1000 lowercase letters, with no whitespace within.
Output
For each test case, output a line containing the minimum number of groups required to partition the
input into groups of palindromes.Universidad de Valladolid OJ: 11584 – Partitioning by Palindromes
Sample Input
3
racecar
fastcar
aaadbccb
Sample Output
1
7
3
题目大意:
给你一个字符串,问你这个字符串最少能拆分成多少个回文串的组合。

#include <bits/stdc++.h>
using namespace std;
//fstream in,out;
bool mark[1001][1001];//用来记录i到j这段字符串是否是回文
int dp[1001];
string s;
int main()
{ios::sync_with_stdio(false);int n;cin>>n;while(n--){cin>>s;memset(dp,0,sizeof(dp));memset(mark,false,sizeof(mark));int len=s.size();for(int i=0;i<len;i++)mark[i][i]=true;for(int i=0;i<len-1;i++)if(s[i]==s[i+1])mark[i+1][i]=mark[i][i+1]=true;//相邻的两个字符相同要先判断for(int k=3;k<=len;k++){for(int i=0;i<len-k+1;i++){int j=k+i-1;if(s[i]==s[j]&&mark[i+1][j-1])mark[j][i]=mark[i][j]=true;}}dp[0]=1;for(int i=1;i<len;i++){if(mark[i][0]){dp[i]=1;continue;}elsedp[i]=INT_MAX;for(int j=1;j<i;j++){if(mark[i][j])dp[i]=min(dp[j-1]+1,dp[i]);}dp[i]=min(dp[i],dp[i-1]+1);}cout<<dp[len-1]<<endl;}return 0;
}

解答:
之前在leetcode上面做过一个最长回文串的题目,没想到在这用上了。用mark[i][j]表示i到j是否是回文串,如果s[i]==s[j]而且mark[i+1][j-1]为真,那么mark[i][]j]肯定为真,也就是i到j是一个回文串。
接下来设置dp[i]表示以字母s[i]为结尾的字符串最少能分解成多少个回文串,那么dp[i]=min(dp[j-1]+1,dp[i]) 当mark[i][j]为真的情况下。
转移方程的意思是如果mark[i][j]为真,那么就把字符串j前面字符能组成最少回文串数加上回文串i到j即可。

这篇关于uva 11584 Partitioning by Palindromes的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/841069

相关文章

uva 10055 uva 10071 uva 10300(水题两三道)

情歌两三首,水题两三道。 好久没敲代码了为暑假大作战热热身。 uva 10055 Hashmat the Brave Warrior 求俩数相减。 两个debug的地方,一个是longlong,一个是输入顺序。 代码: #include<stdio.h>int main(){long long a, b;//debugwhile(scanf("%lld%lld", &

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

uva 10387 Billiard(简单几何)

题意是一个球从矩形的中点出发,告诉你小球与矩形两条边的碰撞次数与小球回到原点的时间,求小球出发时的角度和小球的速度。 简单的几何问题,小球每与竖边碰撞一次,向右扩展一个相同的矩形;每与横边碰撞一次,向上扩展一个相同的矩形。 可以发现,扩展矩形的路径和在当前矩形中的每一段路径相同,当小球回到出发点时,一条直线的路径刚好经过最后一个扩展矩形的中心点。 最后扩展的路径和横边竖边恰好组成一个直

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

uva 568 Just the Facts(n!打表递推)

题意是求n!的末尾第一个不为0的数字。 不用大数,特别的处理。 代码: #include <stdio.h>const int maxn = 10000 + 1;int f[maxn];int main(){#ifdef LOCALfreopen("in.txt", "r", stdin);#endif // LOCALf[0] = 1;for (int i = 1; i <=

uva 575 Skew Binary(位运算)

求第一个以(2^(k+1)-1)为进制的数。 数据不大,可以直接搞。 代码: #include <stdio.h>#include <string.h>const int maxn = 100 + 5;int main(){char num[maxn];while (scanf("%s", num) == 1){if (num[0] == '0')break;int len =

uva 10014 Simple calculations(数学推导)

直接按照题意来推导最后的结果就行了。 开始的时候只做到了第一个推导,第二次没有继续下去。 代码: #include<stdio.h>int main(){int T, n, i;double a, aa, sum, temp, ans;scanf("%d", &T);while(T--){scanf("%d", &n);scanf("%lf", &first);scanf

uva 10916 Factstone Benchmark(打表)

题意是求 k ! <= 2 ^ n ,的最小k。 由于n比较大,大到 2 ^ 20 次方,所以 2 ^ 2 ^ 20比较难算,所以做一些基础的数学变换。 对不等式两边同时取log2,得: log2(k ! ) <=  log2(2 ^ n)= n,即:log2(1) + log2(2) + log2 (3) + log2(4) + ... + log2(k) <= n ,其中 n 为 2 ^

uva 10025 The ? 1 ? 2 ? ... ? n = k problem(数学)

题意是    ?  1  ?  2  ?  ...  ?  n = k 式子中给k,? 处可以填 + 也可以填 - ,问最小满足条件的n。 e.g k = 12  - 1 + 2 + 3 + 4 + 5 + 6 - 7 = 12 with n = 7。 先给证明,令 S(n) = 1 + 2 + 3 + 4 + 5 + .... + n 暴搜n,搜出当 S(n) >=